// Integer.cpp
// Copyright (C) 2010 Miguel Vargas (miguel.vargas@gmail.com)
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include <Basic/Assert.h>
#include <Basic/Debug.h>
#include <Basic/Integer.h>
#include <stdio.h>


FormatInteger::FormatInteger(bool space, bool sign, int width, Type type) throw(Memory::Exception)
:	Format()
{
	Assert(width > 0);

	int size = 3;
	if (space)
	{
		++size;
	}
	if (sign)
	{
		++size;
	}
	for (register int w = width; w; ++size)
	{
		w /= 10;
	}
	*(char**)&format_string = new char[size];
	if (!format_string )
	{
		DebugPosition("Memory::Exception", (char*)0);		
		throw Memory::exception;
	}
	sprintf(*(char**)&format_string, "%%%s%s%i%c", space ? " " : "", sign ? "+" : "", width, (type == decimal) ? 'd' : (type == hexadecimal) ? 'x' : (type == HEXADECIMAL) ? 'X' : 'o');
}
